workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

default:
  image:
    name: bitnami/kubectl:1.30
    entrypoint: ['']

variables:
    KUBE_CONTEXT: liscioapps/getsphere/getsphere:do-gitlab-agent

stages:
  - build
  - deploy
  - notify

build-build-image:
  stage: build
  image: docker:26.1.2-alpine3.19
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes:
        - Dockerfile.gitlab-builder
  services:
    - docker:26.1.2-dind
  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login --username $DOCKER_REGISTRY_USER --password-stdin
  script:
    - docker build --tag liscioapps/sphere-gitlab-builder -f Dockerfile.gitlab-builder .
    - docker push liscioapps/sphere-gitlab-builder

# build-svc:
#   stage: build
#   rules:
#     - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
#   image: liscioapps/sphere-gitlab-builder
#   services:
#     - docker:26.1.2-dind
#   before_script:
#     - echo "$DOCKER_REGISTRY_PASS" | docker login --username $DOCKER_REGISTRY_USER --password-stdin
#   parallel:
#     matrix:
#       - BUILD_ITEM: [elasticmq, nginx, redis, temporal]
#   script:
#     - cd scripts/
#     - ./cli build-and-push $BUILD_ITEM

# build-helpers:
#   stage: build
#   rules:
#     - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
#   image: liscioapps/sphere-gitlab-builder
#   services:
#     - docker:26.1.2-dind
#   before_script:
#     - echo "$DOCKER_REGISTRY_PASS" | docker login --username $DOCKER_REGISTRY_USER --password-stdin
#   parallel:
#     matrix:
#       - BUILD_ITEM: [cubejs]
#   script:
#     - cd scripts/
#     - ./cli build-and-push $BUILD_ITEM

build-workers:
  stage: build
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  image: liscioapps/sphere-gitlab-builder
  services:
    - docker:26.1.2-dind
  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login --username $DOCKER_REGISTRY_USER --password-stdin
  parallel:
    matrix:
      - BUILD_ITEM: [automations-worker, cache-worker, data-sink-worker, emails-worker, entity-merging-worker, exports-worker, integration-run-worker, integration-stream-worker, integration-sync-worker, merge-suggestions-worker, profiles-worker, python-worker, search-sync-api, search-sync-worker, exports-worker, organizations-enrichment-worker, data-sink-worker, integration-run-worker, integration-stream-worker]
  script:
    - cd scripts/
    - ./cli build-and-push $BUILD_ITEM

build-application:
  stage: build
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  image: liscioapps/sphere-gitlab-builder
  services:
    - docker:26.1.2-dind
  before_script:
    - echo "$DOCKER_REGISTRY_PASS" | docker login --username $DOCKER_REGISTRY_USER --password-stdin
  parallel:
    matrix:
      - BUILD_ITEM: [backend, frontend, webhook-api]
  script:
    - cd scripts/
    - ./cli build-and-push $BUILD_ITEM

deploy-ingress:
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
  parallel:
      matrix:
        - DEPLOY_ITEM: [do-nginx, ingress, letsencrypt]
  before_script:
    - kubectl config use-context "$KUBE_CONTEXT"
  script:
    - cd scripts/deploy/kubernetes
    - sed -i "s/:latest/:${CI_COMMIT_SHORT_SHA}/g" $DEPLOY_ITEM.yaml
    - kubectl apply -f $DEPLOY_ITEM.yaml

# deploy-svc:
#   stage: deploy
#   rules:
#     - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
#       when: manual
#   parallel:
#       matrix:
#         - DEPLOY_ITEM: [elasticmq, opensearch, redis, temporal]
#   before_script:
#     - kubectl config use-context "$KUBE_CONTEXT"
#   script:
#     - cd scripts/deploy/kubernetes
#     - sed -i "s/:latest/:${CI_COMMIT_SHORT_SHA}/g" $DEPLOY_ITEM.yaml
#     - kubectl apply -f $DEPLOY_ITEM.yaml

# deploy-helpers:
#   stage: deploy
#   rules:
#     - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
#       when: manual
#   parallel:
#       matrix:
#         - DEPLOY_ITEM: [cubejs, nango, unleash]
#   before_script:
#     - kubectl config use-context "$KUBE_CONTEXT"
#   script:
#     - cd scripts/deploy/kubernetes
#     - sed -i "s/:latest/:${CI_COMMIT_SHORT_SHA}/g" $DEPLOY_ITEM.yaml
#     - kubectl apply -f $DEPLOY_ITEM.yaml

deploy-workers:
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
  parallel:
      matrix:
        - DEPLOY_ITEM: [discord-ws, job-generator, nodejs-worker, python-worker, workers, search-sync-worker, organizations-enrichment-worker]
  before_script:
    - kubectl config use-context "$KUBE_CONTEXT"
  script:
    - cd scripts/deploy/kubernetes
    - sed -i "s/:latest/:${CI_COMMIT_SHORT_SHA}/g" $DEPLOY_ITEM.yaml
    - kubectl apply -f $DEPLOY_ITEM.yaml

deploy-app:
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
  parallel:
      matrix:
        - DEPLOY_ITEM: [api, frontend, webhook-api, search-sync-api]
  before_script:
    - kubectl config use-context "$KUBE_CONTEXT"
  script:
    - cd scripts/deploy/kubernetes
    - sed -i "s/:latest/:${CI_COMMIT_SHORT_SHA}/g" $DEPLOY_ITEM.yaml
    - kubectl apply -f $DEPLOY_ITEM.yaml

notify:
  stage: notify
  image: 
    name: projectdiscovery/notify:latest
    entrypoint: ['']
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script:
    - echo $NOTIFY_CONFIG | base64 -d > .notify-config.yml
    - echo "Deploy Completed for $CI_COMMIT_SHORT_SHA!" | notify -pc .notify-config.yml
